      subroutine bcoher2(nsect,n1,nout,ninp,nmode,nc2blk,c2thresh,
     $                   c2trim,ffts,xindex,c2flag,c2cut,c2,info)
c
c rrrmt version 9
c
c coherence estimation on each section by block averaging
c
c  input variables:
c     nsect--number of sections in ffts
c     n1--number of output time series to process
c     nout--number of output time series
c     ninp--number of input time series
c     nmode--mode switch, 0 for conventional, 1 for remote reference
c     nc2blk--number of sections to average over per block
c     c2thresh-coherence threshold
c     c2trim-coherence trim value
c     ffts--complex array containing nsect section fft's
c           for nout+2*ninp variables
c     xindex--work vector of length nsect
c  output variables:
c     c2flag-logical vector, .true. if coherence threshold is exceeded
c     c2cut-computed coherence cutoff value
c     c2--array containing nsect/nc2blk section average coherence
c         estimates for nout output variables
c     info--error flag, 0 for normal return, 1 for singular matrix
c
      include 'parameters.h'
      complex ffts
      logical c2flag
      dimension ffts(nsectm,nout+2*ninp),xindex(nsect),
     $          c2(nsectm,nout),c2flag(nsectm)
      double precision syy,rcond
      double complex sxrx,sxry,sxx,syx,a,sypyp,syyp
      dimension sxrx(nrefm,nrefm),sxry(nrefm),
     $          sxx(nrefm,nrefm),syx(nrefm),
     $          ipvt(nrefm),a(nrefm)
      info=0
      do 50 n=0,nsect-1,nc2blk
        do 40 m=1,n1
          do 10 i=1,ninp
            sxry(i)=0.
            syx(i)=0.
            do 10 j=1,ninp
              sxx(i,j)=0.
   10         sxrx(i,j)=0.
          syy=0.
          do 20 ii=n+1,n+nc2blk
            syy=syy+abs(ffts(ii,m))**2
            do 20 i=1,ninp
              sxry(i)=sxry(i)+conjg(ffts(ii,i+nout+nmode*ninp))*
     $             ffts(ii,m)
              syx(i)=syx(i)+conjg(ffts(ii,m))*ffts(ii,i+nout)
              do 20 j=1,ninp
                sxx(i,j)=sxx(i,j)+conjg(ffts(ii,i+nout))*
     $                   ffts(ii,j+nout)
   20           sxrx(i,j)=sxrx(i,j)+conjg(ffts(ii,i+nout+nmode*ninp))*
     $                 ffts(ii,j+nout)
          call zgeco(sxrx,nrefm,ninp,ipvt,rcond,a)
          if(1.d0+rcond.eq.1.d0)info=1
          job=0
          call zgesl(sxrx,nrefm,ninp,ipvt,sxry,job)
          sypyp=0.
          syyp=0.
          do 30 i=1,ninp
            a(i)=0.
            do 25 j=1,ninp
   25         a(i)=a(i)+sxx(i,j)*sxry(j)
            syyp=syyp+syx(i)*sxry(i)
   30       sypyp=sypyp+conjg(sxry(i))*a(i)
   40     c2(n/nc2blk+1,m)=abs(syyp)**2/(syy*sypyp)
   50   continue
      if(c2trim.gt.0.)then
        do 60 i=1,nsect/nc2blk
   60     xindex(i)=i
        ncut=nint(c2trim*(nsect/nc2blk))
        c2cut=0.
        do 70 nn=1,n1
          call ssort(c2(1,nn),xindex,nsect/nc2blk,2)
          c2cut=max(c2cut,c2thresh,c2(ncut,nn))
  70      call ssort(xindex,c2(1,nn),nsect/nc2blk,2)
      else
        c2cut=c2thresh
      endif
      if(c2cut.eq.0.)return
      do 80 i=1,nsect/nc2blk
        do 80 nn=1,n1
          if(c2(i,nn).le.c2cut)c2flag(i)=.false.
   80     continue
      return
      end
