      subroutine ccoher(nsct,ninp,ftsec,h,hd1,wt,gd1,g,glo,ghi)
c
c  rrrmt version 9
c
c  compute complex coherence between measured and predicted output variables
c
c  input variables:
c  
c  nsct--number of sections
c  ninp--number of input variables
c  ftsec--complex array containing nsct fft's of 2*ninp+1 variables
c  h--complex array containing transfer functions between output and
c      ninp input variables
c  hd1--complex array of delete one transfer function estimates
c  wt--weight vector
c  gd1--work array of length at least nsct
c  
c  output variables
c  g--complex coherence (not squared coherence!)
c  glo--lower 95% confidence limit on coherence magnitude
c  ghi--upper 95% confidence limit on coherence magnitude
      include 'parameters.h'
      complex ftsec,h,hd1,g
      dimension ftsec(nsectm,2*ninp+1),h(noutm,ninp),
     $          hd1(ninpm,nsct),wt(nsct),gd1(nsct)
      double precision pwr,gd1av,syy,var
      double complex bb,sxx,yps,zt0,t1,sxx1,yp
      dimension bb(ninpm),sxx(ninpm,ninpm),yp(ninpm)
      arctanh(z)=0.5*log((1.+z)/(1.-z))
      pwr=0.
      do 10 i=1,ninp
        bb(i)=0.
        do 10 j=1,ninp
   10     sxx(i,j)=0.
      do 20 ii=1,nsct
        pwr=pwr+(wt(ii)*abs(ftsec(ii,1)))**2
        do 20 i=1,ninp
           bb(i)=bb(i)+wt(ii)*wt(ii)*ftsec(ii,i+1)*
     $                 conjg(ftsec(ii,1))
           do 20 j=1,ninp
   20        sxx(i,j)=sxx(i,j)+wt(ii)*wt(ii)*conjg(ftsec(ii,i+1))*
     $                ftsec(ii,j+1)
      yps=0.
      zt0=0.
      do 30 i=1,ninp
        yp(i)=0.
        do 25 j=1,ninp
   25     yp(i)=yp(i)+sxx(i,j)*h(1,j)
        yps=yps+conjg(h(1,i))*yp(i)
   30   zt0=zt0+bb(i)*h(1,i)
      g=zt0/sqrt(pwr*dreal(yps))
c  compute jackknifed estimate of coherence 95% confidence interval
      gd1av=0.
      nd=0
      do 50 ii=1,nsct
        if(wt(ii).gt.0.)then
          nd=nd+1
          syy=pwr-(wt(ii)*abs(ftsec(ii,1)))**2
          zt0=0.
          yps=0.
          do 40 i=1,ninp
            t1=bb(i)-wt(ii)*wt(ii)*ftsec(ii,i+1)*
     $               conjg(ftsec(ii,1))
            zt0=zt0+t1*hd1(i,ii)
            yp(i)=0.
            do 35 j=1,ninp
              sxx1=sxx(i,j)-wt(ii)*wt(ii)*conjg(ftsec(ii,i+1))*
     $             ftsec(ii,j+1)
   35         yp(i)=yp(i)+sxx1*hd1(j,ii)
   40       yps=yps+conjg(hd1(i,ii))*yp(i)
            gd=abs(zt0)/sqrt(syy*dreal(yps))
            gd1(nd)=arctanh(gd)
            gd1av=gd1av+gd1(nd)
        endif
   50   continue
      gd1av=gd1av/nd
      var=0.
      do 60 i=1,nd
   60   var=var+(gd1av-gd1(i))**2
      err=sqrt((nd-1)*var/nd)
      g1=arctanh(abs(g))
      glo=max(0.,tanh(g1-1.96*err))
      ghi=min(tanh(g1+1.96*err),1.)
      return
      end
