      subroutine dataft(nsect,nf1,nfsect,nfft,noff,nfil,nar,
     $                  dpss,wsave,data,fpar,cpar,arf,fft,ffts)
c  computes fourier transforms of data, corrects for prewhitening
c  and instrument response, and returns selected frequencies
c
c  input variables
c    nsect-number of sections
c    nf1-starting frequency index
c    nfsect-number of frequencies per section starting with nf1
c    nfft-length of fft
c    noff-offset between sections
c    nfil-number of filter parameters in fpar if .gt.0 and
c         indicates filter parameters are contained in file cpar if .lt.0
c    nar-length of ar filter less leading 1
c    dpss-double precision vector containing slepian sequence data window
c    wsave-vector containing sinusoids for fft
c    data-vector containing data sequence
c    fpar-vector of filter parameters
c    cpar-character string of filter parameters
c    arf-vector of ar prewhitening filter coefficients
c    fft-complex work space of length nfft
c
c  output variables
c    ffts-complex array containing fourier transforms for each section
c         at selected frequencies
c    
      include 'parameters.h'
      character*(*) cpar
      double precision dpss,darf,pi,tpi,om,ct,st
      complex ar,fft,ffts,t0,t1,fil,filter1,filter2
      dimension dpss(1),wsave(1),data(1),fpar(1),arf(nar+1),
     $          fft(nfft)
      dimension ffts(nsectm,nfsect)
      dimension darf(narm)
      parameter (pi=3.141592653589793d0,tpi=2.d0*pi)
      xnfft=nfft
      k=1
      nn=nsect/2
      do 30 n=1,2*nn,2
        do 10 i=1,nfft
          fft(i)=dpss(i)*cmplx(data(k),data(k+noff))
   10     k=k+1
        call cfftf(nfft,fft,wsave)
        do 20 i=nf1,nfsect+nf1-1
          if(nfil.gt.0)then
            fil=filter1(float(i)/xnfft,fpar,nfil)
          elseif(nfil.lt.0)then
            fil=filter2(float(i)/xnfft,cpar)
          else
            fil=1.
          endif
          if(nar.gt.0)then
            do 15 ii=1,nar+1
   15         darf(ii)=arf(ii)
            om=tpi*dfloat(i)/dble(xnfft)
            call sft(darf,nar+1,om,ct,st)
            ar=cmplx(ct,st)
          else
            ar=1.
          endif
          t0=fft(i+1)
          t1=fft(nfft-i+1)
          ffts(n,i-nf1+1)=0.5*fil*(t0+conjg(t1))/ar
          ffts(n+1,i-nf1+1)=-cmplx(0.,0.5)*fil*(t0-conjg(t1))/ar
   20     continue
   30   k=k-nfft+2*noff
      if(mod(nsect,2).ne.0)then
        do 40 i=1,nfft
          fft(i)=dpss(i)*data(k)
   40     k=k+1
        call cfftf(nfft,fft,wsave)
        do 60 i=nf1,nfsect+nf1-1
          if(nfil.gt.0)then
            fil=filter1(float(i)/xnfft,fpar,nfil)
          elseif(nfil.lt.0)then
            fil=filter2(float(i)/xnfft,cpar)
          else
            fil=1.
          endif
          if(nar.gt.0)then
            do 50 ii=1,nar+1
   50         darf(ii)=arf(ii)
            om=tpi*dfloat(i)/dble(xnfft)
            call sft(darf,nar+1,om,ct,st)
            ar=cmplx(ct,st)
          else
            ar=1.
          endif
          ffts(nsect,i-nf1+1)=fil*fft(i+1)/ar
   60     continue
      endif
      return
      end
