      subroutine del1(nsect,ninp,ftsec,wt,aa,bb,hd1,info)
c
c  computes delete one transfer functions
c
c  input variables:
c
c  nsect--number of sections
c  ninp--number of input time series
c  ftsec--complex array of nsect section fft's for 2*ninp+1 variables
c  wt--vector of weights
c  aa-double complex array containing input spectral matrix
c  bb-double complex vector containing input/output spectral matrix
c
c  output variables:
c
c  hd1--complex array of delete one responses
c  info-error flag, 0 for normal return, as returned by zgeco otherwise
c
      include 'parameters.h'
      complex ftsec,hd1
      double complex aa,bb,a,b,zz
      double precision rcond
      dimension ftsec(nsectm,2*ninp+1),aa(ninpm,ninp),bb(ninp),
     $          wt(nsect),hd1(ninpm,nsect)
      dimension a(ninpm,ninpm),b(ninpm),ipvt(ninpm),zz(ninpm)
      info=0
      do 10 ii=1,nsect
        do 5 i=1,ninp
          b(i)=bb(i)-wt(ii)**2*conjg(ftsec(ii,i+ninp+1))*ftsec(ii,1)
          do 5 j=1,ninp
    5       a(i,j)=aa(i,j)-wt(ii)**2*conjg(ftsec(ii,i+ninp+1))*
     $             ftsec(ii,j+1)
          call zgeco(a,ninpm,ninp,ipvt,rcond,zz)
          if(1.d0+rcond.eq.1.d0)info=1
          job=0
          call zgesl(a,ninpm,ninp,ipvt,b,job)
          do 10 i=1,ninp
  10        hd1(i,ii)=b(i)
      return
      end
