      subroutine expwt(nsct,u0,scale,res,w)
c  computes exponential (thomson) weights based on regression residuals
c
c  input variables
c    nsct-number of sections
c    u0-parameter for exponential weights
c    scale-robust estimate of scale
c    res-vector of absolute value of residuals
c  output variable
c    w-vector of weights
      dimension res(nsct),w(nsct)
      small=r1mach(1)
      big=log(-log(small)/.05129329)
c  coefficient sets the 0.95 point to res/scale=u0
      sw=exp(-.05129329*exp(-u0**5))
      do 10 i=1,nsct
        t=u0**4*(res(i)/scale-u0)
        if(t.lt.big)then
          w(i)=exp(-.05129329*exp(t))/sw
        else
          w(i)=0.
        endif
   10   continue
      return
      end

