      subroutine hatwt(nsct,ninp,ainl,ainu,l1,l2,hat,what)
c  computes leverage weights based on size of hat matrix diagonal relative
c  to its expected value
c
c  input variables
c    nsct-number of sections
c    ninp-number of inputs
c    ainl-lower cutoff
c    ainu-upper cutoff
c    l1-logical array for number of data eliminated at lower end,
c       changed on return
c    l2-logical array for number of data eliminated at upper end,
c       changed on return
c    hat-vector of hat matrix diagonal entries
c  output variables
c    what-vector of weights
c
      logical l1,l2
      dimension l1(nsct),l2(nsct),hat(nsct),what(nsct)
      small=r1mach(1)
      big=log(-log(small)/.05129329)
      nw=0
      do 5 i=1,nsct
        if(what(i).ne.0.)nw=nw+1
    5   continue
      xnw=nw
      if(ainu.le.0.)goto 20
      ains=ainu
      if(ains.lt.1.)ains=1./ains
      swhat=exp(-.05129329*exp(-ainu*ains**4))
      do 10 i=1,nsct
        t=ains**4*(xnw*hat(i)/ninp-ainu)
        if(t.lt.big)then
          owhat=what(i)
          what(i)=what(i)*exp(-.05129329*exp(t))/swhat
          if((owhat.ne.0.).and.(what(i).eq.0.))l2(i)=.true.
        else
          what(i)=0.
          l2(i)=.true.
        endif
  10    continue
  20  if(ainl.le.0.)return
      ains=ainl
      if(ains.gt.1.)ains=1./ains
      swhat=exp(-.05129329*exp(-ainl/ains**4))
      do 30 i=1,nsct
        t=(xnw*hat(i)/ninp-ainl)/ains**4
        if(t.lt.big)then
          owhat=what(i)
          what(i)=what(i)*(1.-exp(-.05129329*exp(t))/swhat)
          if((owhat.ne.0.).and.(what(i).eq.0.))l1(i)=.true.
        endif
  30    continue
      return
      end
