      subroutine residual(nsect,ninp,ftsec,h,wt,nw,res,resq)
c
c  rrrmt version 9
c
c  returns residuals and residual sum of squares
c
c  input variables
c
c   nsect--number of sections
c   ninp--number of input variables
c   ftsec--complex nsect by nout+ninp array containing fourier transforms
c   h--double complex vector containing ninp transfer function estimates
c   wt--vector of weights
c
c  returned variables
c
c  nw--number of residuals with nonzero weights
c  res--vector of absolute residuals
c  resq--normalized residual sum of squares
c
      include 'parameters.h'
      complex ftsec,resq
      double complex h,ctmp,resq1
      dimension ftsec(nsectm,ninp+1),h(ninp),wt(nsect),res(nsect)
      resq1=0.
      nw=0
      do 20 n=1,nsect
        ctmp=ftsec(n,1)
        if(wt(n).gt.0.)nw=nw+1
        do 10 i=1,ninp
   10     ctmp=ctmp-h(i)*ftsec(n,i+1)
        resq1=resq1+wt(n)**2*dcmplx(dreal(ctmp)**2,dimag(ctmp)**2)
   20   res(n)=abs(ctmp)
      resq=resq1/nw
      return
      end
