      subroutine response(nsect,ninp,wt,ftsec,b,aa,bb,info)
c
c  rrrmt version 9
c
c  computes response function
c
c  input variables
c    nsect-number of sections
c    ninp-number of input variables
c    wt-weight vector of length nsect
c    ftsec-array containing fourier transform estimates
c  output variables
c    b-double complex vector of transfer functions
c    aa-double complex array containing input spectral matrix
c    bb-double complex vector containing input/output cross spectra
c    info-error flag, 0 for normal return and 1 for singular matrix
c
      include 'parameters.h'
      double complex b,aa,bb
      complex ftsec
      double precision rcond
      dimension wt(nsect),ftsec(nsectm,2*ninp+1)
      dimension b(ninp),aa(ninpm,ninp),bb(ninp)
      double complex a,zz
      dimension a(ninpm,ninpm),zz(ninpm),ipvt(ninpm)
      info=0
      do 10 i=1,ninp
        b(i)=0.
        do 10 j=1,ninp
   10     a(i,j)=0.
      do 25 k=1,nsect
        if(wt(k).eq.0.)goto 25
        do 20 i=1,ninp
          b(i)=b(i)+wt(k)**2*conjg(ftsec(k,i+ninp+1))*ftsec(k,1)
          do 20 j=1,ninp
   20       a(i,j)=a(i,j)+wt(k)**2*conjg(ftsec(k,i+ninp+1))*
     $             ftsec(k,j+1)
   25   continue
      do 30 i=1,ninp
        bb(i)=b(i)
        do 30 j=1,ninp
   30     aa(i,j)=a(i,j)
      call zgeco(a,ninpm,ninp,ipvt,rcond,zz)
      if(1.d0+rcond.eq.1.d0)info=1
      job=0
      call zgesl(a,ninpm,ninp,ipvt,b,job)
      return
      end
