      subroutine rotate(nsect,theta1,theta2,phi,fftx,ffty)
c
c  rotate ffts to new coordinate system
c
c  input variables:
c
c  nsect--number of sections
c  theta1--angle of first component pos cw wrt geomagnetic north
c  theta2--angle of second component pos cw wrt geomagnetic north
c  phi--pos cw rotation angle of geomagnetic coordinate system
c  fftx--complex array containing nsect section fft's for
c        x component (overwritten on return)
c  ffty--complex array containing nsect section fft's for
c        y component (overwritten on return)
c
c  output variables:
c
c  fftx--complex array containing nsect section fft's for x component
c  ffty--complex array containing nsect section fft's for y component
c
c  if original data are collected in orthogonal coordinate
c  system, set theta1=0, theta2=90
c
      complex fftx,ffty,t0
      dimension fftx(nsect),ffty(nsect)
      parameter (pi=3.141592653589793,rad=pi/180.)
      if(theta1.eq.0.)then
        spt1=sin(rad*phi)
        cpt1=cos(rad*phi)
      else
        spt1=sin(rad*(phi-theta1))
        cpt1=cos(rad*(phi-theta1))
      endif
      if(theta2.eq.90.)then
        spt2=-cos(rad*phi)
        cpt2=sin(rad*phi)
      else
        spt2=sin(rad*(phi-theta2))
        cpt2=cos(rad*(phi-theta2))
      endif
      st2t1=sin(rad*(theta2-theta1))
      do 10 i=1,nsect
        t0=(-fftx(i)*cpt2+ffty(i)*cpt1)/st2t1
        fftx(i)=(-fftx(i)*spt2+ffty(i)*spt1)/st2t1
 10     ffty(i)=t0
      return
      end
