      subroutine threshold(nsect,nc2blk,nout,ninp,c2flag,wt,
     $                     wtthresh,ffts,nsct,tag,pwro,pwri,ftsec)
c
c  rrrmt version 9
c
c  performs coherence presorting and pre-weights the Fourier transforms
c  as required
c
c  input variables
c    nsect-number of sections
c    nc2blk-number of sections per block used for coherence estimation
c    nout-number of output time series
c    ninp-number of input time series
c    c2flag-logical vector, .true. if block exceeds coherence threshold 
c    wt-weight vector
c    wtthresh-weight threshold, section is rejected if corresponding
c             weight is below this value
c    ffts-complex array containing raw Fourier transforms
c
c  output variables
c    nsct-number of sections output after thresholding
c    tag-vector of section numbers
c    pwr-vector of output section powers
c    pwri-vector of input section powers, assumed to occupy the
c         ninp/2 locations after the first in ftsec
c    ftsec-complex vector containing sorted Fourier transforms
c
      include 'parameters.h'
      complex ffts
      logical c2flag
      dimension c2flag(nsectm),ffts(nsectm,nserm),wt(nsectm)
      complex ftsec
      dimension tag(nsect),pwro(nsect),pwri(nsect),
     $          ftsec(nsectm,ninp+1)
      k=1
      do 50 kk=0,nsect-1,nc2blk
        if(.not.c2flag(kk/nc2blk+1))goto 50
	do 40 ii=kk+1,kk+nc2blk
	  if(wt(ii).le.wtthresh)goto 40
          ftsec(k,1)=ffts(ii,1)
          do 25 j=nout+1,nout+ninp
   25       ftsec(k,j-nout+1)=ffts(ii,j)
          tag(k)=float(ii)
          pwro(k)=abs(ftsec(k,1))**2
          pwri(k)=0.
          do 35 j=1,ninp/2
   35       pwri(k)=pwri(k)+abs(ftsec(k,j+1))**2
	  pwri(k)=pwri(k)/ninp
          k=k+1
   40     continue
   50   continue
      nsct=k-1
      return
      end
