      subroutine transfer(nsect,nref,wt,ftsec,b,info)
c
c  rrrmt version 9
c
c  computes transfer function between local and reference variables
c
c  input variables
c    nsect-number of sections
c    nref-number of reference variables
c    wt-weight vector of length nsect
c    ftsec-array containing fourier transform estimates
c  output variables
c    b-double complex vector of transfer functions
c    info-error flag, 0 for normal return and 1 for singular matrix
c
      include 'parameters.h'
      double complex b
      complex ftsec
      double precision rcond
      dimension wt(nsect),ftsec(nsectm,nref+1)
      dimension b(nrefm)
      double complex a,zz
      dimension a(nrefm,nrefm),zz(nrefm),ipvt(nrefm)
      info=0
      do 10 i=1,nref
        b(i)=0.
        do 10 j=1,nref
   10     a(i,j)=0.
      do 25 k=1,nsect
        if(wt(k).eq.0.)goto 25
        do 20 i=1,nref
          b(i)=b(i)+wt(k)**2*conjg(ftsec(k,i+1))*ftsec(k,1)
          do 20 j=1,nref
   20       a(i,j)=a(i,j)+wt(k)**2*conjg(ftsec(k,i+1))*
     $             ftsec(k,j+1)
   25   continue
      call zgeco(a,nrefm,nref,ipvt,rcond,zz)
      if(1.d0+rcond.eq.1.d0)info=1
      job=0
      call zgesl(a,nrefm,nref,ipvt,b,job)
      return
      end
